﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using C1.WPF.C1Chart;
using System.Diagnostics;

namespace WpfChartMarker
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
            chart.Data.Children.Add(CreateDataSeries(20));    
            chart.ChartType = ChartType.LineSymbols;

            var pnl = new ChartPanel();

            var dt = (DataTemplate)Resources["marker"];
            var cpo = (ChartPanelObject)dt.LoadContent();

            cpo.DataPoint = new Point(5, double.NaN);
            cpo.Action = ChartPanelAction.MouseMove;

            cpo.Attach = ChartPanelAttach.DataXY;

            pnl.Children.Add(cpo);

            chart.Data.Children[0].PlotElementLoaded += (s, e) =>
            {
                if (!(s is Lines))
                {
                    var pe = s as PlotElement;
                    pe.MouseLeftButtonUp += (s1, e1) =>
                     {
                         MessageBox.Show(string.Format("Point Clicked {0}:{1}", (pe.DataPoint as C1.WPF.C1Chart.XYDataSeries.XYDataPoint).X, (pe.DataPoint as C1.WPF.C1Chart.XYDataSeries.XYDataPoint).Y));
                         pnl.Background = new SolidColorBrush(Colors.Transparent);
                     };
                }

            };

            chart.PreviewMouseLeftButtonUp += (s, e) =>
             {
                 // to handle the scenario when ChartPanel is directly clicked
                 pnl.Background = new SolidColorBrush(Colors.Transparent);
             };
            pnl.MouseLeftButtonDown += (s, e) =>
            {
                pnl.Background = null;
            };

            chart.View.Layers.Add(pnl);    
        }

       

        public  DataSeries CreateDataSeries(int npts)
        {
            var ds = new XYDataSeries(){ SymbolSize = new Size(10, 10), ConnectionStrokeThickness = 1 };
            Random rnd = new Random(); 
            int cnt = npts;
            var x = new double[cnt];
            var y = new double[cnt];
            

            for (int i = 0; i < cnt; i++)
            {
                x[i] = i; y[i] = rnd.NextDouble()*100;
            }

                ds.XValuesSource = x; ds.ValuesSource = y;
                return ds;
        }
    }


   
}
